﻿var clothBlockW,clothBlockH,itemBlockW,itemBlockH;
var cloth_bnum_now;
var frameInterval;

/* Colors */
var ballColor,barColor,itemBarColor,itemBlockColor,blockBorderColor;
var messageColor,backgroundColor;

/* Size of ball and bar*/
var ballW,ballH,barW,barH;

/* Ball speed */
var ballVX,ballVY;

/* Layer */
var layerNum,clothBlockLayer;

/* Test mode flag */
var test_mode=false;

/* Help for seeking cloth blocks */
var clothBlockHelpNum=0;

/* All animation images */
var anmImg; // [anmImgNum]
var anmImgFName = new Array(); // [anmImgNum]
var anmImgNum=0;

/* All item animations */
var itemAnmNum;
var itemAnmImgNum; // [itemAnmNum]
var itemAnmImgN,itemAnmFrm; // [itemAnmNum][itemAnmImgNum[i]]

/* Items */
var itemNum;
var itemBX,itemBY,itemBW,itemBH,itemInitFrm,itemType;
var itemOX,itemOY,itemImgFront;
var itemLayer,itemBlockLayer,itemBlockAreaLayer;
var itemBlockImgN;
var item_bnum_now;
var itemState,itemAnmFrm_now,itemAnmImg_now,itemInitFrm_now;
var itemMX0,itemMY0,itemMX1,itemMY1,itemMFrm,itemMFrm_now;

/* Target animations */
var tgAnmNum;
var tgAnmScnNum,tgAnmScnLoop; // [tgAnmNum]
var tgAnmScnImgNum,tgAnmScnFrm; // [tgAnmNum][tgAnmScnNum[i]]
var tgAnmScnImgN,tgAnmScnImgX,tgAnmScnImgY,tgAnmScnImgLayer; // [tgAnmNum][tgAnmScnNum[i]][tgAnmScnImgNum[i][j]]

/* Target instances and connections */
var itemTgCnctNum=0;
var nkTgCnctNum=0;
var nkLvNum,nkLvMax,tgNum;
var tgRVecNum,tgRVecENum,tgAnm_now,tgScn_now,tgFrm_now; //[tgNum]
var nkTgCnct=new Array(); // [nkTgCnctNum]
var itemTgCnct=new Array(); // [itemTgCnctNum][2]
var tgRAnm; // [tgNum][tgRVecNum[i]]
var tgVec_now; // [tgNum][tgRVecENum[i]]
var tgRVec; // [tgNum][tgRVecNum[i]][tgRVecENum[i]]
var itemTgVec=new Array() // [itemTgCnctNum][tgRVecENum[i]]
var nkTgLvVec=new Array(); // [nkTgCnctNum][tgRVecENum[iTg]]

var st_init,i_init;

var app_w,app_h,err_code;
var buffer,buffer2,bg_img,fg_img;
var theFont;

var life;
var st_stage,now_stage;
var ball_x,ball_y,ball_vx,ball_vy;
var block_n;
var bar_x,bar_y;

var block_x,block_y,block_st,block_item; // [block_n]

var nowTime;
var canvas;
var ctx;

function setItemAnmNum(n){
  itemAnmNum=n;
  itemAnmImgNum=new Array(n);
  itemAnmImgN=new Array(n);
  itemAnmFrm=new Array(n);
}

function setItemAnmImgNum(i,n){
  itemAnmImgNum[i]=n;
  itemAnmImgN[i]=new Array(n);
  itemAnmFrm[i]=new Array(n);
}

function setItemImgPr(i,j,fName,nFr){
  itemAnmImgN[i][j]=getAnmImgN(fName);
  itemAnmFrm[i][j]=nFr;
}

function setItemTypeNum(n){
  var i;

  itemTypeNum=n;
  itemTypeStAnm=new Array(n);
  for(i=0;i<itemTypeNum;i++) itemTypeStAnm[i]=new Array(2);
  itemTypeJntX=new Array(n);
  itemTypeJntY=new Array(n);
}

function setItemType(i,iAnm0,iAnm1,jntX,jntY){
  itemTypeStAnm[i][0]=iAnm0;
  itemTypeStAnm[i][1]=iAnm1;
  itemTypeJntX[i]=jntX;
  itemTypeJntY[i]=jntX;
}

function setItemNum(n){
  var i;

  itemNum=n;
  itemType=new Array(n);
  itemState=new Array(n);
  itemAnmImg_now=new Array(n);
  itemAnmFrm_now=new Array(n);
  itemInitFrm_now=new Array(n);
  itemBX=new Array(n);
  itemBY=new Array(n);
  itemBW=new Array(n);
  itemBH=new Array(n);
  itemInitFrm=new Array(n);
  itemOX=new Array(n);
  itemOY=new Array(n);
  itemImgFront=new Array(n);
  itemLayer=new Array(n);
  itemBlockLayer=new Array(n);
  itemBlockAreaLayer=new Array(n);
  item_bnum_now=new Array(n);
  itemMX0=new Array(n);
  itemMY0=new Array(n);
  itemMX1=new Array(n);
  itemMY1=new Array(n);
  itemMFrm=new Array(n);
  itemMFrm_now=new Array(n);
  itemBlockImgN=new Array(n);
  for(i=0;i<n;i++){
    itemState[i]=0;
    itemAnmImg_now[i]=0;
    itemAnmFrm_now[i]=0;
    itemInitFrm_now[i]=0;
    itemMFrm_now[i]=0;
  }
}

function setItemPr(i,iType,bX,bY,bW,bH,oX,oY,mX0,mY0,mX1,mY1,mFrmNum,initFrm,fName,il,bl,bal){
  itemType[i]=iType;
  itemBX[i]=bX;
  itemBY[i]=bY;
  itemBW[i]=bW;
  itemBH[i]=bH;
  if(oX>=0) itemOX[i]=oX;
  else itemOX[i]=Math.floor(bX+bW*itemBlockW/2);
  if(oY>=0) itemOX[i]=oY;
  else itemOY[i]=Math.floor(bY+bH*itemBlockH/2);
  itemMX0[i]=mX0;
  itemMY0[i]=mY0;
  itemMX1[i]=mX1;
  itemMY1[i]=mY1;
  itemMFrm[i]=mFrmNum;
  itemInitFrm[i]=initFrm;
  itemBlockImgN[i]=getAnmImgN(fName);
  itemLayer[i]=il;
  itemBlockLayer[i]=bl;
  itemBlockAreaLayer[i]=bal;
}

function setTgAnmNum(n){
  tgAnmNum=n;
  tgAnmScnNum=new Array(tgAnmNum);
  tgAnmScnLoop=new Array(tgAnmNum);
  tgAnmScnImgNum=new Array(tgAnmNum);
  tgAnmScnFrm=new Array(tgAnmNum);
  tgAnmScnImgN=new Array(tgAnmNum);
  tgAnmScnImgX=new Array(tgAnmNum);
  tgAnmScnImgY=new Array(tgAnmNum);
  tgAnmScnImgLayer=new Array(tgAnmNum);
}

function setTgAnmScnNum(i,n){
  tgAnmScnNum[i]=n;
  tgAnmScnFrm[i]=new Array(n);
  tgAnmScnImgNum[i]=new Array(n);
  tgAnmScnImgN[i]=new Array(n);
  tgAnmScnImgX[i]=new Array(n);
  tgAnmScnImgY[i]=new Array(n);
  tgAnmScnImgLayer[i]=new Array(n);
  tgAnmScnLoop[i]=0;
}

function setTgAnmScnImgNumFrm(i,j,n,frm){
  var k;

  tgAnmScnImgNum[i][j]=n;
  tgAnmScnImgN[i][j]=new Array(n);
  tgAnmScnImgX[i][j]=new Array(n);
  tgAnmScnImgY[i][j]=new Array(n);
  tgAnmScnImgLayer[i][j]=new Array(n);
  for(k=0;k<n;k++) tgAnmScnImgLayer[i][j][k]=0;
  tgAnmScnFrm[i][j]=frm;
}

function setTgAnmScnImgPr(i,j,k,fName,imgX,imgY){
  tgAnmScnImgN[i][j][k]=getAnmImgN(fName);
  tgAnmScnImgX[i][j][k]=imgX;
  tgAnmScnImgY[i][j][k]=imgY;
}

function setTgNum(n){
  var i;

  tgNum=n;
  tgRVecNum=new Array(n);
  tgRVecENum=new Array(n);
  tgAnm_now=new Array(n);
  for(i=0;i<n;i++) tgAnm_now[i]= -1;
  tgScn_now=new Array(n);
  tgFrm_now=new Array(n);
  tgRAnm=new Array(n);
  tgVec_now=new Array(n);
  tgRVec=new Array(n);
}

function setTgRVecNumENum(i,n,en){
  var j;

  tgRVecNum[i]=n;
  tgRVecENum[i]=en;
  tgRAnm[i]=new Array(n);
  tgVec_now[i]=new Array(en);
  tgRVec[i]=new Array(n);
  for(j=0;j<n;j++) tgRVec[i][j]=new Array(en);
}

function setTgRVecAnm(i,j,sv,ia){
  var svec;
  var k;

  svec=sv.split(",");
  for(k=0;k<tgRVecENum[i];k++) tgRVec[i][j][k]=parseFloat(svec[k]);
  tgRAnm[i][j]=ia;
}

function setNkLvNum(n,m){
  nkLvNum=n;
  nkLvMax=m;
  if(nkLvMax<nkLvNum-1) nkLvMax=nkLvNum-1;
  else if(nkLvMax>nkLvNum) nkLvMax=nkLvNum;
}

function addNkLvTgVec(iLv,iTg,sv){
  var svec;
  var k;

  nkTgCnct[nkTgCnctNum]=new Array(2);
  nkTgCnct[nkTgCnctNum][0]=iLv;
  nkTgCnct[nkTgCnctNum][1]=iTg;
  nkTgLvVec[nkTgCnctNum]=new Array(tgRVecENum[iTg]);
  svec=sv.split(",");
  for(k=0;k<tgRVecENum[iTg];k++) nkTgLvVec[nkTgCnctNum][k]=parseFloat(svec[k]);
  nkTgCnctNum++;
}

function addItemTgVec(iItem,iTg,iSt,sv){
  var svec;
  var k;

  itemTgCnct[itemTgCnctNum]=new Array(3);
  itemTgCnct[itemTgCnctNum][0]=iItem;
  itemTgCnct[itemTgCnctNum][1]=iTg;
  itemTgCnct[itemTgCnctNum][2]=iSt;
  itemTgVec[itemTgCnctNum]=new Array(tgRVecENum[iTg]);
  svec=sv.split(",");
  for(k=0;k<tgRVecENum[iTg];k++) itemTgVec[itemTgCnctNum][k]=parseFloat(svec[k]);
  itemTgCnctNum++;
}

function getAnmImgN(fName){
  var rtn,i;

  if((rtn=searchAnmImg(fName))<0){
    rtn=anmImgNum;
    anmImgFName[rtn]=fName;
    anmImgNum++;
  }
  return rtn;
}

function searchAnmImg(fName){
  var i;
  var found;

  i=0;
  found=false;
  while((!found)&&(i<anmImgNum)){
    if(fName==anmImgFName[i]) found=true;
    else i++;
  }
  if(!found) i= -1;
  return i;
}

function reset_ball(){
  st_stage=0; /* Waiting for mouse down for start */
  bar_x=(app_w-barW)/2;
  bar_y=app_h-barH;
  ball_x=bar_x+(barW-ballW)/2;
  ball_y=bar_y-ballH;
  ball_vx=0;
  ball_vy=0;
}

function paint(){
  var i,ilayer;

  if(st_init>0){
    ctx.fillStyle = "black";
    ctx.fillRect(0,0,app_w,app_h);
    ctx.fillStyle=messageColor;
    ctx.fillText("Now loading...",0,25);
  } else{
    ctx.drawImage(bg_img,0,0);
    for(ilayer=0;ilayer<layerNum;ilayer++){
      draw_targets(ilayer);
      if(now_stage==0){
        for(i=0;i<itemNum;i++){
          if(ilayer==itemBlockAreaLayer[i]){
            if(itemBlockImgN[i]>=0){
              draw_anmImg(itemBlockImgN[i],itemBX[i],itemBY[i]);
            } else{
              ctx.fillStyle(itemBlockColor);
              ctx.fillRect(itemBX[i],itemBY[i],
                            itemBW[i]*itemBlockW,itemBH[i]*itemBlockH);
            }
          }
        }
        draw_blocks(ilayer);
      } else{
        draw_blocks(ilayer);
        draw_items(ilayer);
      }
    }
  }
  if(st_init<=0){
    ctx.fillStyle=barColor;
    ctx.fillRect(bar_x,bar_y,barW,barH);
    ctx.fillStyle=ballColor;
    ctx.fillRect(ball_x,ball_y,ballW,ballH);
    ctx.fillStyle=messageColor;
    if(st_stage==0){
      ctx.fillText("Push mouse button to start!",0,app_h-40);
      if(life>0){
         ctx.fillText("Life = "+life,0,app_h-20);
      }
    }else if(st_stage==2){
      ctx.fillText("Game over!!",0,app_h-40);
    }
  }
}

function draw_blocks(ilayer){
  var i;

  for(i=0;i<block_n;i++){
    if(block_st[i]==1){
      if(block_item[i]<0){
        if(ilayer==clothBlockLayer){
          ctx.drawImage(fg_img,block_x[i],block_y[i],clothBlockW,clothBlockH,
                        block_x[i],block_y[i],clothBlockW,clothBlockH);
          if(test_mode||(cloth_bnum_now<=clothBlockHelpNum)){
            ctx.strokeStyle=blockBorderColor;
            ctx.lineWidth=1;
            ctx.beginPath();
            ctx.moveTo(block_x[i],block_y[i]);
            ctx.lineTo(block_x[i]+clothBlockW-1,block_y[i]);
            ctx.moveTo(block_x[i],block_y[i]);
            ctx.lineTo(block_x[i],block_y[i]+clothBlockH-1);
            ctx.closePath();
            ctx.stroke();
          }
        }
      } else if(ilayer==itemBlockLayer[block_item[i]]){
        if(itemBlockImgN[block_item[i]]>=0){
          ctx.drawImage(anmImg[itemBlockImgN[block_item[i]]],
                        block_x[i]-itemBX[block_item[i]],block_y[i]-itemBY[block_item[i]],
                        itemBlockW,itemBlockH,
                        block_x[i],block_y[i],itemBlockW,itemBlockH);
        } else{
          ctx.fillStyle=itemBlockColor;
          ctx.fillRect(block_x[i],block_y[i],itemBlockW,itemBlockH);
        }
        ctx.strokeStyle=blockBorderColor;
        ctx.lineWidth=1;
        ctx.beginPath();
        ctx.moveTo(block_x[i],block_y[i]);
        ctx.lineTo(block_x[i]+itemBlockW-1,block_y[i]);
        ctx.moveTo(block_x[i],block_y[i]);
        ctx.lineTo(block_x[i],block_y[i]+itemBlockH-1);
        ctx.closePath();
        ctx.stroke();
      }
    }
  }
}

function draw_targets(ilayer){
  var i,j,i_anm,i_scn,ix,iy;

  for(i=0;i<tgNum;i++){
    i_anm=tgAnm_now[i];
    i_scn=tgScn_now[i];
    if(i_anm>=0){
      for(j=0;j<tgAnmScnImgNum[i_anm][i_scn];j++){
        if(tgAnmScnImgLayer[i_anm][i_scn][j]==ilayer){
          ix=tgAnmScnImgX[i_anm][i_scn][j];
          iy=tgAnmScnImgY[i_anm][i_scn][j];
          draw_anmImg(tgAnmScnImgN[i_anm][i_scn][j],ix,iy);
        }
      }
    }
  }
}

function draw_items(ilayer){
  var i,ix,iy,jntx,jnty,im,imh,itype,ianm,iimgn;

  for(i=0;i<itemNum;i++){
    if((item_bnum_now[i]<=0)&&(itemLayer[i]==ilayer)){
      iimgn= -1;
      itype=itemType[i];
      if(itype>=0){
        ianm=itemTypeStAnm[itype][itemState[i]];
        if(ianm>=0){
          iimgn=itemAnmImgN[ianm][itemAnmImg_now[i]];
        }
      }
      if(itemState[i]==0){
        im=itemInitFrm_now[i];
        imh=itemInitFrm[i];
        ix=Math.floor((1.0*itemOX[i]*(imh-im)+1.0*(itemMX0[i]*im))/imh);
        iy=Math.floor((1.0*itemOY[i]*(imh-im)+1.0*(itemMY0[i]*im))/imh);
      } else{
        im=itemMFrm_now[i];
        imh=itemMFrm[i]/2;
        if(im>=imh) im=itemMFrm[i]-im;
        ix=Math.floor((1.0*itemMX0[i]*(imh-im)+1.0*(itemMX1[i]*im))/imh);
        iy=Math.floor((1.0*itemMY0[i]*(imh-im)+1.0*(itemMY1[i]*im))/imh);
      }
      jntx=0;
      jnty=0;
      if((itype>=0)&&(itype<itemTypeNum)){
        jntx=itemTypeJntX[itype];
        jnty=itemTypeJntY[itype];
      }
      if(itemImgFront[i]==0){
        if(iimgn>=0) draw_anmImg(iimgn,ix-jntx,iy-jnty);
        ctx.strokeStyle=itemBarColor;
        ctx.lineWidth=1;
        ctx.beginPath();
        ctx.moveTo(itemOX[i],itemOY[i]);
        ctx.lineTo(ix,iy);
        ctx.closePath();
        ctx.stroke();
      } else{
        ctx.strokeStyle=itemBarColor;
        ctx.lineWidth=1;
        ctx.beginPath();
        ctx.moveTo(itemOX[i],itemOY[i]);
        ctx.lineTo(ix,iy);
        ctx.closePath();
        ctx.stroke();
        if(iimgn>=0) draw_anmImg(iimgn,ix-jntx,iy-jnty);
      }
    }
  }
}

function draw_anmImg(iimgn,ix,iy){
  ctx.drawImage(anmImg[iimgn],ix,iy);
}

function mouseMove(e){
  var rect=e.target.getBoundingClientRect();
  var x=e.clientX-rect.left;
  var y=e.clientY-rect.top;
  bar_x=x-barW/2;
  if(st_stage==0){
    ball_x=bar_x+(barW-ballW)/2;
  }
}

function mouseDown(e){
  var rect=e.target.getBoundingClientRect();
  var x=e.clientX-rect.left;
  var y=e.clientY-rect.top;

  if(st_stage==0){
    st_stage=1; /* playing */
    ball_vx= ballVX;
    ball_vy= -ballVY;
  }
  if(test_mode){
    ball_x=x;
    ball_y=y;
    move_ball(true);
  }
}

function my_init(){
  var complete;

  if(st_init==1){
    bg_img=new Image();
    bg_img.src=nakedImg;
    st_init=2;
    bg_img.onload=function(){
      st_init=3;
    }
  } else if(st_init==3){
    fg_img=new Image();
    fg_img.src=clothImg;
    st_init=4;
    fg_img.onload=function(){
      st_init=5;
    }
  } else if(st_init==5){
    anmImg=new Array(anmImgNum);
    i_init=0;
    st_init=6;
  } else if(st_init==6){
    if(i_init>=anmImgNum) st_init=12;
    else{
      if(test_mode){
        //console.log("Getting Animation image "+anmImgFName[i_init]);
      }
      anmImg[i_init]=new Image();
      anmImg[i_init].src=anmImgFName[i_init];
      st_init=7;
      anmImg[i_init].onload=function(){
        i_init++;
        st_init=6;
      }
    }
  } else if(st_init==12){
    dist_ClothImg();
    if(block_n<=0){
      init_item_block();
      reset_ball();
    }
    else{
      reset_ball();
      now_stage=0;
      st_init=0;
    }
    st_init=0;
  }
}

function dist_ClothImg(){
  var nx,ny,ix,iy,jx,jy,i,j,k,pix_i,bl_w,bl_h;
  var img_w,img_h,num;
  var found;
  var mycanvas;
  var myctx;
  var pix;

  block_n=0;
  if(fg_img!=null){
    if(test_mode){
      //console.log("Distributing ClothImg into blocks.");
    }
    img_w=fg_img.width;
    img_h=fg_img.height;
    ny=Math.floor(img_h/clothBlockH);
    nx=Math.floor(img_w/clothBlockW);
    block_n=nx*ny;
    block_x=new Array(block_n);
    block_y=new Array(block_n);
    block_st=new Array(block_n);
    block_item=new Array(block_n);
    mycanvas=document.createElement('canvas');
    mycanvas.width=img_w;
    mycanvas.height=img_h;
    myctx=mycanvas.getContext('2d');
    myctx.drawImage(fg_img,0,0);
    pix=myctx.getImageData(0,0,img_w,img_h);
    i=0;
    for(iy=0;iy<ny;iy++){
      for(ix=0;ix<nx;ix++){
        found=false;
        jy=0;
        while((!found)&&(jy<clothBlockH)){
          pix_i=(img_w*(iy*clothBlockH+jy)+ix*clothBlockW)*4+3;
          jx=0;
          while((!found)&&(jx<clothBlockW)&&(clothBlockW*ix+jx<img_w)){
            if(pix.data[pix_i]>=128) found=true;
            else{
              jx++;
              pix_i+=4;
            }
          }
          jy++;
        }
        if(found){
          block_x[i]=ix*clothBlockW;
          block_y[i]=iy*clothBlockH;
          block_st[i]=1;
          block_item[i]= -1;
          i++;
        }
      }
    }
    block_n=i;
  }
  cloth_bnum_now=block_n;
}

function init_item_block(){
  var i,j,ix,iy;

  block_n=0;
  item_bnum_now=new Array(itemNum);
  for(i=0;i<itemNum;i++){
    item_bnum_now[i]=itemBW[i]*itemBH[i];
    block_n+=item_bnum_now[i];
  }
  block_x=new Array(block_n);
  block_y=new Array(block_n);
  block_st=new Array(block_n);
  block_item=new Array(block_n);
  j=0;
  for(i=0;i<itemNum;i++){
    for(iy=0;iy<itemBH[i];iy++){
      for(ix=0;ix<itemBW[i];ix++){
        block_x[j]=itemBX[i]+itemBlockW*ix;
        block_y[j]=itemBY[i]+itemBlockH*iy;
        block_st[j]=1;
        block_item[j]=i;
        j++;
      }
    }
  }
  now_stage=1;
}

onload = function() {
  canvas = document.getElementById('id_canvas');
  ctx = canvas.getContext('2d');
  ctx.font="20px 'TimeRoman'";
  app_w=canvas.width;
  app_h=canvas.height;
  setParam();
  canvas.onmousemove=mouseMove;
  canvas.onmousedown=mouseDown;
  st_init=1;
  setInterval("loop()",frameInterval);
}

function loop(){
  paint();
  if(st_init>0) my_init();
  else{
    if(st_stage==1){
      if(!test_mode) move_ball(false);
      if((now_stage==0)&&(cloth_bnum_now<=0)) init_item_block();
      if(ball_y>app_h){
        if(life>0) life--;
        if(life==0){
          ball_vx=0;
          ball_vy=0;
          st_stage=2;
        } else reset_ball();
      }
    }
    if(now_stage==1){
      move_items();
    }
    tg_evaluate();
  }
}

function hit_rect(x1,y1,w1,h1,x2,y2,w2,h2){
  return ((Math.max(x1,x2)<=Math.min(x1+w1,x2+w2))&&
          (Math.max(y1,y2)<=Math.min(y1+h1,y2+h2)));
}

function move_ball(is_test){
  var i,j,k,n_div,block_w,block_h;
  var b_vx,b_vy,b_x,b_y;

  n_div=16;
  b_vx=ball_vx/n_div;
  b_vy=ball_vy/n_div;
  b_x=ball_x;
  b_y=ball_y;
  for(i=0;i<n_div;i++){
    for(j=0;j<block_n;j++){
      if(block_st[j]==1){
        if(block_item[j]<0){
          block_w=clothBlockW;
          block_h=clothBlockH;
        } else{
          block_w=itemBlockW;
          block_h=itemBlockH;
        }
        if(hit_rect(b_x,b_y,ballW,ballH,
                    block_x[j],block_y[j],block_w,block_h)){
          block_st[j]=0;
          if(block_item[j]<0){
            cloth_bnum_now--;
          } else{
            item_bnum_now[block_item[j]]--;
          }
          if(((b_vx<0)&&(b_x+ballW>block_x[j]+block_w))||
             ((b_vx>=0)&&(b_x<block_x[j])))
            b_vx= -b_vx;
          if(((b_vy<0)&&(b_y+ballH>block_y[j]+block_h))||
             ((b_vy>=0)&&(b_y<block_y[j])))
            b_vy= -b_vy;
        }
      }
    }
    if(((b_vx<0)&&(b_x<=0))||((b_vx>0)&&(b_x>=app_w-ballW)))
      b_vx= -b_vx;
    if(((b_vy<0)&&(b_y<=0))||
       ((b_vy>0)&&
        hit_rect(b_x,b_y,ballW,ballH,
                 bar_x,bar_y,barW,barH)))
      b_vy= -b_vy;
    if(!is_test){
      b_x+=b_vx;
      b_y+=b_vy;
    }
  }
  ball_x=b_x;
  ball_y=b_y;
  ball_vx=b_vx*n_div;
  ball_vy=b_vy*n_div;
}

function move_items(){
  var i,itype,ianm;

  for(i=0;i<itemNum;i++){
    if(item_bnum_now[i]<=0){
      itype=itemType[i];
      if(itype>=0){
        ianm=itemTypeStAnm[itype][itemState[i]];
        if(ianm>=0){
          itemAnmFrm_now[i]++;
          if(itemAnmFrm[ianm][itemAnmImg_now[i]]<=itemAnmFrm_now[i]){
            itemAnmImg_now[i]++;
            if(itemAnmImgNum[ianm]<=itemAnmImg_now[i]){
              itemAnmImg_now[i]=0;
            }
            itemAnmFrm_now[i]=0;
          }
        }
      }
      if(itemState[i]==0){
        if(itemInitFrm_now[i]>=itemInitFrm[i]) itemState[i]=1;
        else itemInitFrm_now[i]++;
      } else{
        itemMFrm_now[i]++;
        if(itemMFrm_now[i]>=itemMFrm[i]) itemMFrm_now[i]=0;
      }
    }
  }
}

function tg_evaluate(){
  var i,j,k,nk_lv,i_item,i_tg,i_st,i_r,i_anm;
  var wd,dist,min_dist;

  nk_lv=get_nk_lv();
  for(i=0;i<tgNum;i++){
    for(j=0;j<tgRVecENum[i];j++){
      tgVec_now[i][j]=0.0;
    }
  }
  for(i=0;i<nkTgCnctNum;i++){
    if(nk_lv==nkTgCnct[i][0]){
      i_tg=nkTgCnct[i][1];
      for(j=0;j<tgRVecENum[i_tg];j++){
        tgVec_now[i_tg][j]+=nkTgLvVec[i][j];
      }
    }
  }
  for(i=0;i<itemTgCnctNum;i++){
    i_item=itemTgCnct[i][0];
    i_tg=itemTgCnct[i][1];
    i_st=itemTgCnct[i][2]
    for(j=0;j<tgRVecENum[i_tg];j++){
      if((now_stage==1)&&(item_bnum_now[i_item]<=0)&&(itemState[i_item]==i_st)){
        tgVec_now[i_tg][j]+=itemTgVec[i][j];
      }
    }
  }
  for(i=0;i<tgNum;i++){
    min_dist=0.0;
    i_r=-1;
    for(j=0;j<tgRVecNum[i];j++){
      dist=0;
      for(k=0;k<tgRVecENum[i];k++){
        wd=tgRVec[i][j][k]-tgVec_now[i][k];
        dist+=wd*wd;
      }
      if((i_r<0)||(min_dist>dist)){
        min_dist=dist;
        i_r=j;
      }
    }
    if(i_r>=0) i_anm=tgRAnm[i][i_r];
    else i_anm= -1;
    if(i_anm!=tgAnm_now[i]){
      tgAnm_now[i]=i_anm;
      tgScn_now[i]=0;
      tgFrm_now[i]=0;
    }
    else if((i_anm>=0)&&(i_anm<tgAnmNum)){
      tgFrm_now[i]++;
      if(tgFrm_now[i]>=tgAnmScnFrm[i_anm][tgScn_now[i]]){
        tgFrm_now[i]=0;
        tgScn_now[i]++;
        if(tgScn_now[i]>=tgAnmScnNum[i_anm]){
          tgScn_now[i]=tgAnmScnLoop[i_anm];
        }
      }
    }
  }
}

function get_nk_lv(){
  var nk_lv;

  if(now_stage==0){
    nk_lv=nkLvNum*(block_n-cloth_bnum_now)/block_n;
    if(nk_lv>nkLvMax) nk_lv=nkLvMax;
  } else{
    nk_lv=nkLvMax;
  }
  return Math.floor(nk_lv);
}
